<template>
  <div>
    <v-dialog v-model="mostrardatos" persistent max-width="1200">
      <v-card>
        <div class="btnCerrarModal" @click="cancelarAlerta">
          <div>X</div>
        </div>
        <DatosSucursalEKT
          v-if="negocio == 1"
          v-model="datos"
          :lectura="lectura"
          :guardarEditar="guardarEditar"
          :callbackInsertaDatosSucursal="callbackInsertaDatosSucursal"
          ref="datosSucursalEKT"
        />
        <DatosSucursalBAZ
          v-if="negocio == 2"
          v-model="datos"
          :lectura="lectura"
          :guardarEditar="guardarEditar"
          :callbackInsertaDatosSucursal="callbackInsertaDatosSucursal"
          ref="datosSucursalBAZ"
        />
        <DatosSucursalCYC
          v-if="negocio == 3"
          v-model="datos"
          :lectura="lectura"
          :guardarEditar="guardarEditar"
          :callbackInsertaDatosSucursal="callbackInsertaDatosSucursal"
          ref="datosSucursalCYC"
        />
        <DatosSucursalPP
          v-if="negocio == 4"
          v-model="datos"
          :lectura="lectura"
          :guardarEditar="guardarEditar"
          :callbackInsertaDatosSucursal="callbackInsertaDatosSucursal"
          ref="datosSucursalPP"
        />
        <DatosSucursalITK
          v-if="negocio == 5"
          v-model="datos"
          :lectura="lectura"
          :guardarEditar="guardarEditar"
          :callbackInsertaDatosSucursal="callbackInsertaDatosSucursal"
          ref="datosSucursalITK"
        />
      </v-card>
    </v-dialog>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Infraestructura</strong>
    </div>
    <div class="contSecc">
      <div class="titSecCard">Listado de documentos</div>
      <v-card style="background-color: #fafafa">
        <div>
          <BusquedaCeco :callback="callBackCeco" v-model="listaCeco"></BusquedaCeco>
        </div>
        <v-row v-if="formatos.length > 0" justify="center">
          <v-chip-group active-class="primary--text">
            <template v-for="(formato, index) in formatos">
              <v-chip
                class="ma-1"
                @click="
                  formatoSeleccionado = formato.idFormato;
                  getProyectos(cecoSeleccionado, formato.idFormato);
                  filterTable(formato.idFormato, null, null, null);
                "
                active-class="chip-selected"
                color="primary"
                :value="formato"
                link
                outlined
                pill
                :key="index"
                >{{ formato.nombreFormato }}</v-chip
              >
            </template>
          </v-chip-group>
        </v-row>
        <v-row v-if="proyectos.length > 0" justify="center">
          <v-chip-group active-class="primary--text">
            <template v-for="(proyecto, index) in proyectos">
              <v-chip
                class="ma-1"
                @click="
                  proyectoSeleccionado = proyecto.idProyecto;
                  getDocumentos(proyecto.idProyecto);
                  filterTable(formatoSeleccionado, proyecto.idProyecto, null, null);
                "
                active-class="chip-selected"
                color="primary"
                :value="proyecto"
                link
                outlined
                pill
                :key="index"
                >{{ proyecto.nombreProyecto }}</v-chip
              >
            </template>
          </v-chip-group>
        </v-row>
        <v-row v-if="documentos.length > 0" justify="center">
          <v-chip-group active-class="primary--text">
            <template v-for="(docum, index) in documentos">
              <v-chip
                class="ma-1"
                @click="
                  documentoSeleccionado = docum.idDocumento;
                  filterTable(
                    formatoSeleccionado,
                    proyectoSeleccionado,
                    docum.idDocumento,
                    null
                  );
                "
                active-class="chip-selected"
                color="primary"
                :value="docum"
                link
                outlined
                pill
                :key="index"
                >{{ docum.nombreDocumento }}</v-chip
              >
            </template>
          </v-chip-group>
        </v-row>
      </v-card>

      <div style="margin-top: 50px" class="titSecCard">Resultado de la busqueda</div>
      <v-card style="background-color: #fafafa">
        <div class="gris" style="margin-top: 15px">
          <v-row justify="end">
            <v-col :cols="12" :xs="2" :sm="2" :md="2" :lg="2" :xl="2">
              <select-anio v-on:anioSelected="handlerAnio"> </select-anio>
            </v-col>
          </v-row>

          <v-data-table
            :headers="headers"
            :items="items"
            item-key="idFolio"
            :loading="loading"
            :dense="true"
            :fixed-header="true"
            class="custom-table"
            hide-default-footer
          >
            <template v-slot:item.idNegocio="{ item }" }>
              {{ getNegocio(item.idNegocio) }}
            </template>
            <template v-slot:item.fecha="{ item }" }>
              {{ formatDate(item.fecha) }}</template
            >
            <template v-slot:item.verArchivo="{ item }" }>
              <div class="link" @click="redirecciona(item.ruta, item.idFolio)">
                Ver Archivo
              </div>
            </template>
            <template v-slot:item.listadoVersiones="{ item }" }>
              <div class="link" @click="redireccionaListaVersiones(item.idArchivo)">
                Ver Versiones
              </div>
            </template>
            <template v-slot:item.detalles="{ item }" }>
              <div class="link" @click="redireccionaCreaVersion(item)">
                Ver Detalles
              </div></template
            >
            <template v-slot:item.descargar="{ item }" }>
              <div
                class="link"
                @click="
                  descargar(item.ruta, item.idFolio, item.nombreArchivo, item.extension)
                "
              >
                Descargar
              </div>
              <a id="dwnldLnk" download="nombre.pdf" style="display: none" />
            </template>
          </v-data-table>
        </div>
      </v-card>
    </div>
  </div>
</template>
<style scoped>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.theme--light.v-data-table.v-data-table--fixed-header thead {
  border-bottom: #ffcd00 3px solid;
}
.theme--light.v-data-table.v-data-table--fixed-header thead th {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(odd) {
  background-color: #fafafa;
}

div.custom-table div table tbody tr:nth-child(even) {
  background-color: #f0f0f0;
}

div.custom-table div table tbody tr:hover {
  background-color: #ffcd0059 !important;
}
div.custom-table .t-footer {
  background-color: #fafafa;
}
.v-data-table.custom-table.theme--light.v-data-table {
  background-color: #fafafa;
}
</style>
<script>
import store from "@/store";
import router from "@/router";
import moment from "moment";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
import BusquedaCeco from "@/views/secure/infraestructura/visualizador-documentos/componentes/BusquedaCeco.vue";
import SelectAnio from "./componentes/SelectAnio.vue";
import DatosSucursalEKT from "./componentes2/DatosSucursalEKT";
import DatosSucursalBAZ from "./componentes2/DatosSucursalBAZ";
import DatosSucursalCYC from "./componentes2/DatosSucursalCYC";
import DatosSucursalPP from "./componentes2/DatosSucursalPP";
import DatosSucursalITK from "./componentes2/DatosSucursalITK";
export default {
  components: {
    BusquedaCeco,
    SelectAnio,
    DatosSucursalEKT,
    DatosSucursalBAZ,
    DatosSucursalCYC,
    DatosSucursalPP,
    DatosSucursalITK,
  },
  name: "infraestructura_layouts_documentos_geografia_negocio",
  component: {
    BusquedaCeco,
    SelectAnio,
  },

  data: (vm) => ({
    data: [],
    listaCeco: {
      descripcion: "",
      idCeco: "",
      value: "",
    },
    negocio: 0,
    datos: {
      dataCeco: {
        ceco: "",
      },
      dataUnidadNegocio: {
        value: {
          idNegocio: 0,
        },
      },
    },
    lectura: true,
    mostrardatos: false,
    cecoSeleccionado: null,

    directorioArbol: null,
    loading: false,
    headers: [
      { text: "Nombre", value: "nombreArchivo", align: "center" },
      //{ text: "Descripcion", value: "descripcionArchivo", align: "center" },
      { text: "Negocio", value: "idNegocio", align: "center" },

      { text: "Formato", value: "nombreFormato", aligin: "center" },
      { text: "Proyecto", value: "nombreProyecto", align: "center" },
      { text: "Documento", value: "nombreDocumento", align: "center" },
      { text: "Tipo de Archivo", value: "extension", align: "center" },
      { text: "Fecha", value: "fecha", align: "center" },
      { text: "Version", value: "idVersion", align: "center" },
      { text: "Ver Archivo", value: "verArchivo", aligin: "center" },
      {
        text: "Listado de Versiones",
        value: "listadoVersiones",
        aligin: "center",
      },
      { text: "Detalles", value: "detalles", aligin: "center" },
      //{ text: "Nueva Version", value: "nuevaVersion", aligin: "center" },
      { text: "Descargar", value: "descargar", aligin: "center" },
    ],
    items: [],
    itemsAll: [],
    itemsP: [],
    formatos: [],
    proyectos: [],
    documentos: [],
    negocios: [],

    breadcrumbs: [
      {
        text: "Plataforma de Franquicia",
        disabled: false,
        exact: true,
        to: {
          name: "home",
        },
      },
      {
        text: "Administracion Layouts",
        disabled: false,
        exact: true,
        to: {
          name: "infraestructura_layouts_administrador_layouts",
        },
      },
      {
        text: "Archivos",
        disabled: true,
      },
    ],
    formatoSeleccionado: null,
    proyectoSeleccionado: null,
    documentoSeleccionado: null,
    anioSeleccionado: null,
    filteredByAnio: [],
  }),
  created() {
    this.years();
  },
  methods: {
    getNegocio(idNegocio) {
      for (var i = 0; i < this.negocios.length; i++) {
        console.log(this.negocios[i].descripcion);
        if (idNegocio == this.negocios[i].idNegocio) {
          return this.negocios[i].descripcion;
        }
      }
    },
    getNegocios() {
      axios(
        "http://10.89.85.167:8080/plataforma-franquicia-core/api-local/documento-sucursal/negocio/v1/"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.negocios = data.resultado.negocios;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    guardarEditar() {
      //No se usa pero se tiene que declarar
    },

    callbackInsertaDatosSucursal() {
      //No se usa pero se tiene que declarar
    },
    cancelarAlerta() {
      this.mostrardatos = false;
    },
    filterByAnio() {
      var anioFiltered = this.anioSeleccionado;
      if (anioFiltered != null) {
        this.items = this.items.filter(
          (x) => moment(x.fecha).format("YYYY") == anioFiltered
        );
      }
    },
    filterTable(formato, proyecto, documento, anio) {
      this.items = this.itemsAll;
      if (formato != null) {
        this.items = this.items.filter((x) => x.idFormato == formato);
      }
      if (proyecto != null) {
        this.items = this.items.filter((x) => x.idProyecto == proyecto);
      }
      if (documento != null) {
        this.items = this.items.filter((x) => x.idDocumento == documento);
      }
      this.filterByAnio();
      /* if (proyecto != null && documento == null && anio == null) {
        this.items = this.itemsAll.filter((x) => x.idProyecto == proyecto);
        this.getDocumentos(proyecto);
      } else if (documento != null && proyecto != null && anio == null) {
        this.items = this.itemsAll.filter(
          (x) => x.idDocumento == documento && x.idProyecto == proyecto
        );
      } else if (proyecto != null && documento != null && anio != null) {
        this.items = this.itemsAll.filter(
          (x) =>
            x.idDocumento == documento &&
            x.idProyecto == proyecto &&
            moment(x.fecha).format("YYYY") == anio
        );
      } else {
        this.items = this.itemsAll.filter(
          (x) => moment(x.fecha).format("YYYY") == anio
        );
      }
      this.filterByAnio();*/
    },
    handlerAnio(date) {
      this.anioSeleccionado = date;
      this.filterTable(
        this.formatoSeleccionado,
        this.proyectoSeleccionado,
        this.documentoSeleccionado,
        this.anioSeleccionado
      );
    },
    years() {
      const year = new Date().getFullYear();
      var listaYears = Array.from(
        { length: year - 2019 },
        (value, index) => 2020 + index
      );
      this.listaAños = listaYears.sort((a, b) => b - a);
    },
    formatDate(date) {
      return moment(date).format("DD-MM-YYYY");
    },
    callBackCeco(ceco, nombreCeco) {
      this.proyectos = [];
      this.documentos = [];
      var self = this;
      self.items = [];
      axios("/documento-sucursal/virtuales-archivos/v1/virtuales/archivos/ceco/" + ceco)
        .then((response) => {
          let data = response.data;
          if (data) {
            self.cecoSeleccionado = "" + ceco;
            if (nombreCeco != " ") {
              localStorage.nombreSucursal = nombreCeco;
            }
            console.log(self.cecoSeleccionado);

            //Solo PDF
            //self.items = data.resultado.archivosCentroCosto;
            self.items = this.getPDFArchivos(data.resultado.archivosCentroCosto);

            self.itemsAll = self.items;
            this.getFormatos(self.cecoSeleccionado);
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getPDFArchivos(archivosCeco) {
      var itemsFiltradosPerfil = [];

      archivosCeco.forEach((archivoCeco) => {
        if (archivoCeco.extension.includes("pdf")) {
          itemsFiltradosPerfil.push(archivoCeco);
        }
      });

      return itemsFiltradosPerfil;
    },
    getFormatos(ceco) {
      axios
        .post("/documento-sucursal/ceco-proyecto-folio/v1/formato/ceco", {
          idCeco: ceco,
        })
        .then((response) => {
          let data = response.data;
          if (data) {
            this.formatos = data.resultado;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getProyectos(ceco, idformato) {
      this.documentos = [];
      var self = this;
      axios
        .post("/documento-sucursal/ceco-proyecto-folio/v1/", {
          idProyecto: "",
          centroCostos: ceco,
          idFormato: idformato.toString(),
        })
        .then((response) => {
          let data = response.data;
          if (data) {
            self.proyectos = data.resultado.proyectosCentroCosto;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getDocumentos(idProyecto) {
      this.documentos = [];
      this.itemsP = this.items;
      axios("/documento-sucursal/proyectoDocumento/v1/" + idProyecto).then((response) => {
        let data = response.data;
        if (data) {
          this.documentos = data.resultado.proyectoDocumentos;
        }
      });
    },
    flterbyDocument(idDocuemnto) {
      this.items = this.itemsP.filter((x) => x.idDocumento == idDocuemnto);
    },
    redirecciona(uuid, folio) {
      router.push({
        name: "infraestructura_layouts_visualizador_pdf",
        params: {
          uuid: uuid,
          folio: folio,
          source: "infraestructura_layouts_documentos_geografia_negocio",
        },
      });
    },
    redireccionaListaVersiones(idArchivo) {
      router.push({
        name: "infraestructura_layouts_version_documentos",
        params: {
          idArchivo: idArchivo,
          source: 334,
        },
      });
    },
    redireccionaCreaVersion(itemSeleccionado) {
      if (itemSeleccionado.idNegocio > 0) {
        this.datos.dataCeco.ceco = itemSeleccionado.idCeco;
        this.datos.dataUnidadNegocio.value.idNegocio = itemSeleccionado.idNegocio;
        this.negocio = itemSeleccionado.idNegocio;
        this.mostrardatos = true;
        console.log(itemSeleccionado.idCeco);
        console.log(itemSeleccionado.idNegocio);
      }
      /*router.push({
        name: "infraestructura_layouts_nueva_version_documento",
        params: { item: itemSeleccionado },
      });*/
    },
    descargar(uuid, folio, nombre, extencion) {
      const self = this;
      axios(
        "/documento-sucursal/archivos/v1/" + folio + "/archivos/" + uuid + "/contenido"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let initialDoc = data.resultado.archivo;

            var dlnk = document.getElementById("dwnldLnk");

            dlnk.href = initialDoc;
            if (extencion == "dwg") {
              dlnk.download = nombre.split(".")[0] + "." + extencion;
            } else {
              dlnk.download = nombre.split(".")[0] + ".pdf";
            }

            dlnk.click();
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
  },
  mounted() {
    this.getNegocios();
    if (localStorage.cecoSelect) {
      this.cecoSeleccionado = parseInt(localStorage.cecoSelect);
      this.callBackCeco(this.cecoSeleccionado, " ");
    }
  },
  watch: {
    cecoSeleccionado(newData) {
      localStorage.cecoSelect = newData;
    },
  },
};
</script>
